#include <windows.h>

#include <fstream>
#include <iostream>
#include <string>

using namespace std;

void replace_all ( std::string & str, std::string const & pattern, std::string const & replacement ) {

	std::string::size_type start = str.find( pattern, 0 );

	while ( start != str.npos ) {
		str.replace( start, pattern.size(), replacement );
		start = str.find( pattern, start+replacement.size() );
	}

}

int main(int argc, char** argv ) {

	string classpath, command;
	
	//influential environment variables
	string JAVA_HOME = getenv( "JAVA_HOME" );
	string WIRK3_HOME = getenv( "WIRK3_HOME" );
	//string PWD = getenv( "CD" );

	//get the pwd
	string pwd;
	system( "CD > cd.dat" );
	ifstream file( "cd.dat" ) ;
	getline(file, pwd);
	file.close();
	system( "del cd.dat" );
	
	
	//set the classpath
	//WIRK3_HOME + "\\ant-scripts\\tasks\\orangevolt\\roxes-win32forjava-1.1.1.jar;" + WIRK3_HOME + "\\ant-scripts\\tasks\\orangevolt\\orangevolt-ant-tasks-1.3.8.jar;" + 
	classpath = pwd + "\\installer\\cp;" + JAVA_HOME + "\\lib\\tools.jar;" + WIRK3_HOME + "\\lib\\serializer.jar;" + WIRK3_HOME + "\\lib\\xalan.jar;" + WIRK3_HOME + "\\lib\\xercesImpl.jar;" + WIRK3_HOME + "\\lib\\xml-apis.jar;" + WIRK3_HOME + "\\bin\\apache-ant-1.6.5\\lib\\ant-antlr.jar;" + WIRK3_HOME + "\\bin\\apache-ant-1.6.5\\lib\\ant-apache-bcel.jar;" + WIRK3_HOME + "\\bin\\apache-ant-1.6.5\\lib\\ant-apache-bsf.jar;" + WIRK3_HOME + "\\bin\\apache-ant-1.6.5\\lib\\ant-apache-log4j.jar;" + WIRK3_HOME + "\\bin\\apache-ant-1.6.5\\lib\\ant-apache-oro.jar;" + WIRK3_HOME + "\\bin\\apache-ant-1.6.5\\lib\\ant-apache-regexp.jar;" + WIRK3_HOME + "\\bin\\apache-ant-1.6.5\\lib\\ant-apache-resolver.jar;" + WIRK3_HOME + "\\bin\\apache-ant-1.6.5\\lib\\ant-commons-logging.jar;" + WIRK3_HOME + "\\bin\\apache-ant-1.6.5\\lib\\ant-commons-net.jar;" + WIRK3_HOME + "\\bin\\apache-ant-1.6.5\\lib\\ant-icontract.jar;" + WIRK3_HOME + "\\bin\\apache-ant-1.6.5\\lib\\ant-jai.jar;" + WIRK3_HOME + "\\bin\\apache-ant-1.6.5\\lib\\ant.jar;" + WIRK3_HOME + "\\bin\\apache-ant-1.6.5\\lib\\ant-javamail.jar;" + WIRK3_HOME + "\\bin\\apache-ant-1.6.5\\lib\\ant-jdepend.jar;" + WIRK3_HOME + "\\bin\\apache-ant-1.6.5\\lib\\ant-jmf.jar;" + WIRK3_HOME + "\\bin\\apache-ant-1.6.5\\lib\\ant-jsch.jar;" + WIRK3_HOME + "\\bin\\apache-ant-1.6.5\\lib\\ant-junit.jar;" + WIRK3_HOME + "\\bin\\apache-ant-1.6.5\\lib\\ant-launcher.jar;" + WIRK3_HOME + "\\bin\\apache-ant-1.6.5\\lib\\ant-netrexx.jar;" + WIRK3_HOME + "\\bin\\apache-ant-1.6.5\\lib\\ant-nodeps.jar;" + WIRK3_HOME + "\\bin\\apache-ant-1.6.5\\lib\\ant-starteam.jar;" + WIRK3_HOME + "\\bin\\apache-ant-1.6.5\\lib\\ant-stylebook.jar;" + WIRK3_HOME + "\\bin\\apache-ant-1.6.5\\lib\\ant-swing.jar;" + WIRK3_HOME + "\\bin\\apache-ant-1.6.5\\lib\\ant-trax.jar;" + WIRK3_HOME + "\\bin\\apache-ant-1.6.5\\lib\\ant-vaj.jar;" + WIRK3_HOME + "\\bin\\apache-ant-1.6.5\\lib\\ant-weblogic.jar;" + WIRK3_HOME + "\\bin\\apache-ant-1.6.5\\lib\\ant-xalan1.jar;" + WIRK3_HOME + "\\bin\\apache-ant-1.6.5\\lib\\ant-xslp.jar;" + WIRK3_HOME + "\\bin\\apache-ant-1.6.5\\lib\\xercesImpl.jar;" + WIRK3_HOME + "\\bin\\apache-ant-1.6.5\\lib\\xml-apis.jar;" + WIRK3_HOME + "\\bin\\ant-installer\\lib\\ai-icons-amaranth.jar;" + WIRK3_HOME + "\\bin\\ant-installer\\lib\\ai-icons-bluecurve.jar;" + WIRK3_HOME + "\\bin\\ant-installer\\lib\\ai-icons-crystalsvg.jar;" + WIRK3_HOME + "\\bin\\ant-installer\\lib\\ai-icons-eclipse.jar;" + WIRK3_HOME + "\\bin\\ant-installer\\lib\\ai-icons-krystaline.jar;" + WIRK3_HOME + "\\bin\\ant-installer\\lib\\ant-installer-ext.jar;" + WIRK3_HOME + "\\bin\\ant-installer\\lib\\ant-installer.jar;" + WIRK3_HOME + "\\bin\\ant-installer\\lib\\jgoodies-edited-1_2_2.jar;" + WIRK3_HOME + "\\bin\\ant-installer\\lib\\xercesImpl.jar;" + WIRK3_HOME + "\\bin\\ant-installer\\lib\\xml-apis.jar;" + WIRK3_HOME + "\\bin\\ant-installer\\classes";
	putenv( ("CLASSPATH=" + classpath).c_str() );

	//check that it worked
	//string changed_classpath = getenv("CLASSPATH");
	//cout << "classpath: " << changed_classpath << endl;
	
	//create the command
	command = WIRK3_HOME + "\\bin\\apache-ant-1.6.5\\bin\\ant.bat -f " + WIRK3_HOME + "\\ant-scripts\\build.xml -Dwirk3.home=" + WIRK3_HOME;
	//pass on the arguments
	string a;
	for ( int i=0; i < argc; i++ ) {
		a = argv[i];
			
		if ( a.compare("-help") == 0 ) {
			//show_help();
			return 0;
		
		} else if ( a.compare("-cp") == 0) {
			cout << classpath;
			return 0;

		} else if ( a.compare("-sim") == 0 ) {
			command += " -Dexecute=false";

		} else if ( a.compare("-descend") == 0 ) {
			command += " -Dresume.mode=descend";
			
		} else if ( a.compare("-from") == 0 ) {
			command = command + " -Dresume.from=" + argv[++i];
			//from=`echo $2 | sed 's/compile/1/g' | sed 's/create-distributions/2/g' | sed 's/create-installer/3/g' | sed 's/wrap/4/g'`
			//toexec=$toexec$from
		} else if ( a.compare("-to") == 0 ) {
			command = command + " -Dresume.to=" + argv[++i];
			//to=`echo $2 | sed 's/compile/1/g' | sed 's/create-distributions/2/g' | sed 's/create-installer/3/g' | sed 's/wrap/4/g'`
			//toexec=$toexec$to
		} else {
			command = command + " " + a;
		}

	}

	
	//use forward slashes for everything else
	//replace_all( pwd, "\\", "/" );
	
	//set the basedir in the command
	command = command + " -Dbasedir=";
	command = command + pwd;


	
	//command = command + ".";

	cout
		<< "O-----------------------------------------O" << endl
		<< "|                                         |" << endl
		<< "|   WiRK3                                 |" << endl
		<< "|   Windows Release Kit for Greenstone3   |" << endl
		<< "|                                         |" << endl
		<< "O-----------------------------------------O" << endl
		;
	
	cout << "pwd: " << pwd << endl;
	cout << "command: " << command << endl;

	system( command.c_str() );
	
	return 0;

}